/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorValidateResultDetail]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorValidateResultDetailProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorValidateResultDetail]のクラス。
 *
 * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorValidateResultDetailBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratorvalidateresultdetail&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorValidateResultDetailTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorValidateResultDetailTask extends Task {
    /**
     * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)
     */
    protected BlancoNLpackGeneratorValidateResultDetailProcessInput fInput = new BlancoNLpackGeneratorValidateResultDetailProcessInput();

    /**
     * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)
     */
    protected boolean fIsFieldSourcefileProcessed = false;

    /**
     * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)
     */
    protected boolean fIsFieldCheckendoflineperiodProcessed = false;

    /**
     * 指定されたResultDetailファイルの妥当性をチェックします。(主に翻訳部分の妥当性チェックを実施)
     */
    protected boolean fIsFieldCheckcolonProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイル。例: conf/BlancoNLpackGeneratorTranslationFragment.csv<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcefile(final String arg) {
        fInput.setSourcefile(arg);
        fIsFieldSourcefileProcessed = true;
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイル。例: conf/BlancoNLpackGeneratorTranslationFragment.csv<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcefile() {
        return fInput.getSourcefile();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイル。例: tmp/validate/BlancoNLpackGeneratorTranslationFragmentValidateLog.csv<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイル。例: tmp/validate/BlancoNLpackGeneratorTranslationFragmentValidateLog.csv<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[checkendoflineperiod]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * 文末のピリオドをチェックするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setCheckendoflineperiod(final boolean arg) {
        fInput.setCheckendoflineperiod(arg);
        fIsFieldCheckendoflineperiodProcessed = true;
    }

    /**
     * Antタスクの[checkendoflineperiod]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 文末のピリオドをチェックするかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getCheckendoflineperiod() {
        return fInput.getCheckendoflineperiod();
    }

    /**
     * Antタスクの[checkcolon]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * コロン(:)をチェックするかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setCheckcolon(final boolean arg) {
        fInput.setCheckcolon(arg);
        fIsFieldCheckcolonProcessed = true;
    }

    /**
     * Antタスクの[checkcolon]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * コロン(:)をチェックするかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getCheckcolon() {
        return fInput.getCheckcolon();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorValidateResultDetailTask begin.");

        // 項目番号[1]、アトリビュート[sourcefile]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcefileProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcefile]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[targetfile]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetfileProcessed == false) {
            throw new BuildException("必須アトリビュート[targetfile]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcefile:[" + getSourcefile() + "]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- checkendoflineperiod:[" + getCheckendoflineperiod() + "]");
            System.out.println("- checkcolon:[" + getCheckcolon() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorValidateResultDetailProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorValidateResultDetailProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorValidateResultDetailProcess proc = new BlancoNLpackGeneratorValidateResultDetailProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorValidateResultDetailBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
